Public Class Form1

#Region " Private Variablen "
    'Die Liste, die Personen enthlt und als XML-Datei gespeichert werden
    'kann
    Private m_Personen As Personenliste

    'Die Varible TextBoxAktualisierung ist immer beim Wechsel von einer 
    'Person zur nchsten (und damit bei nderungen der Text-Box-Inhalte 
    'fr Nachanme, Vorname...) True
    Private TextBoxAktualisierung As Boolean = False

    'Variablen, die den Sortier-Zustand im ListView festhalten
    Private ListeIst_Nachname_AbstSortiert As Boolean = False
    Private ListeIst_Vorname_AbstSortiert As Boolean = False

    'Die Variable m_Moving ist True, wenn nur Elemente im ListView
    'verschoben werden (Dann brauchen Inhalte der TextBoxen nicht 
    'aktualisiert werden)
    Private m_Moving As Boolean = False
#End Region

#Region " Start "
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Icon = My.Resources.Personensammlung
        Me.ImageList1.Images.Add(My.Resources.Mann)
        Me.ImageList1.Images.Add(My.Resources.Frau)

        'Herstellen einer Verknpfung zwischen Dateien und Anwendung 
        Dim AD As New Anwendungsdaten
        AD.Icon_Verknpfung_herstellen()

        Dim StartPfad As String = ""
        If My.Application.CommandLineArgs.Count > 0 Then
            'Bei Doppelklick auf eine "*.pslst"-Datei wird mit den
            'OpenArgs der Pfad der Datei geliefert.
            Dim Args As String = ""
            For Each txt As String In My.Application.CommandLineArgs
                Args &= " " & txt
            Next
            Args = Args.Trim
            If Args.EndsWith("/open/") Then
                StartPfad = Args.Substring(0, Args.Length - 7).Trim
            End If
        End If

        If StartPfad <> "" Then
            m_Personen = New Personenliste(StartPfad)
            Personenliste_Lesen()
            If ListView1.Items.Count > 0 Then
                ListView1.Items(0).Selected = True
            End If
        Else
            m_Personen = New Personenliste
        End If
    End Sub
#End Region

#Region " ListView neu fllen / Sortieren "

    Private Sub Personenliste_Lesen()
        'Neuauffllung des ListView
        Me.ListView1.Items.Clear()

        For Each P As Person In m_Personen
            Me.ListView1.Items.Add(New PersonListViewItem(P))
        Next
        ListViewAenderung()
    End Sub

    Private Sub ListView1_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListView1.ColumnClick
        'Sortieren der Elemente im ListView (und der Datei)
        'bei Klick auf einen ColumnHeader
        m_Moving = True

        If m_Personen.Count = 0 Then Exit Sub
        Dim SelPerson As Person = Nothing
        If ListView1.SelectedItems.Count > 0 Then
            Dim SelLVI As PersonListViewItem = ListView1.SelectedItems(0)
            SelPerson = SelLVI.Person
        End If

        Select Case e.Column
            Case 0
                If ListeIst_Nachname_AbstSortiert Then
                    m_Personen.Sort(New PersonComparer(True, True))
                    ListeIst_Nachname_AbstSortiert = False
                    ListeIst_Vorname_AbstSortiert = False
                Else
                    m_Personen.Sort(New PersonComparer(True, False))
                    ListeIst_Nachname_AbstSortiert = True
                    ListeIst_Vorname_AbstSortiert = False
                End If
            Case 1
                If ListeIst_Vorname_AbstSortiert Then
                    m_Personen.Sort(New PersonComparer(False, True))
                    ListeIst_Vorname_AbstSortiert = False
                    ListeIst_Nachname_AbstSortiert = False
                Else
                    m_Personen.Sort(New PersonComparer(False, False))
                    ListeIst_Vorname_AbstSortiert = True
                    ListeIst_Nachname_AbstSortiert = False
                End If
        End Select
        Personenliste_Lesen()
        If SelPerson IsNot Nothing Then
            For Each LVI As PersonListViewItem In Me.ListView1.Items
                If LVI.Person Is SelPerson Then
                    LVI.Selected = True
                    Exit For
                End If
            Next
        End If

        m_Personen.Geaendert = True
        m_Moving = False
    End Sub

#End Region

#Region " Menelemente "

    Private Sub NeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuToolStripMenuItem.Click
        'Entspricht "Datei->Neu"
        If Not SpeichernErfolgreich() Then Exit Sub
        m_Personen = New Personenliste
        Personenliste_Lesen()
    End Sub

    Private Sub ffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffnenToolStripMenuItem.Click
        'Entspricht "Datei->ffnen"
        If Not SpeichernErfolgreich() Then Exit Sub

        Dim Dlg As New OpenFileDialog

        Dlg.Filter = "Personenliste-Dateien (*.pslst)|*.pslst"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True

        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_Personen = New Personenliste(Dlg.FileName)
            Personenliste_Lesen()
            If ListView1.Items.Count > 0 Then
                ListView1.Items(0).Selected = True
            End If
        End If

    End Sub

    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click
        'Entspricht "Datei->Speichern"
        SpeichernErfolgreich()
    End Sub

    Private Sub SpeichernunterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernunterToolStripMenuItem.Click
        'Entspricht "Datei->Speichern unter"
        Speichern_Unter_Erfolgreich()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        'Entspricht "Datei->Beenden"
        'Es wird versucht, das Formular zu schlieen, die Frage nach dem Speichern wird 
        'im FormClosing-Handler gestellt
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'wenn das Formular geschlossen wird, 
        'Frage, ob gespeichert werden soll
        'Beim Abbruch des Speicherns bleibt das Formular offen
        If Not SpeichernErfolgreich() Then
            e.Cancel = True
        End If
    End Sub

#End Region

#Region " Speichern "

    Private Function Speichern_Unter_Erfolgreich() As Boolean
        Dim Dlg As New SaveFileDialog

        Dlg.Filter = "Personenliste-Dateien (*.pslst)|*.pslst"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True
        Dlg.AddExtension = True
        Dlg.OverwritePrompt = False
        If m_Personen.Pfad <> "" Then
            Dlg.FileName = m_Personen.Pfad
        Else
            Dlg.FileName = FreienPfadFinden(Environment.GetFolderPath(Environment.SpecialFolder.Personal), _
            "Personen", ".pslst")
        End If


        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_Personen.Pfad = Dlg.FileName
            m_Personen.Speichern()
            Return True
        End If
        Return False
    End Function

    Private Function SpeichernErfolgreich() As Boolean
        'Dies Funktion liefert nur False, wenn das Speichern abgebrochen wird
        'ansonsten wird entweder gespeichert oder darauf verzichtet
        If m_Personen.Geaendert Then
            Dim Result As DialogResult = MessageBox.Show("nderungen speichern?", _
            "Personensammlung", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            If Result = Windows.Forms.DialogResult.Yes Then
                If m_Personen.Pfad <> "" Then
                    m_Personen.Speichern()
                    Return True
                Else
                    'Wenn die Datei noch keinen Pfad hat, wird Speichern unter..
                    'aufgerufen
                    Return Speichern_Unter_Erfolgreich()
                End If
            ElseIf Result = Windows.Forms.DialogResult.No Then
                Return True
            ElseIf Result = Windows.Forms.DialogResult.Cancel Then
                Return False
            End If
        Else
            Return True
        End If
    End Function

#End Region

#Region " nderungen im ListView "

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        ListViewAenderung()
    End Sub

    Private Sub ListViewAenderung()
        If m_Moving AndAlso ListView1.SelectedItems.Count = 0 Then Exit Sub

        If ListView1.SelectedItems.Count = 0 Then
            Me.ButtonDelete.Enabled = False
            Me.ButtonDown.Enabled = False
            Me.ButtonUp.Enabled = False
        Else
            Me.ButtonDelete.Enabled = True
            Dim Idx As Integer = ListView1.SelectedItems(0).Index
            If Idx = 0 Then
                Me.ButtonUp.Enabled = False
            Else
                Me.ButtonUp.Enabled = True
            End If
            If Idx = ListView1.Items.Count - 1 Then
                Me.ButtonDown.Enabled = False
            Else
                Me.ButtonDown.Enabled = True
            End If
        End If
        AktuellePerson_Lesen()
    End Sub

    Private Sub AktuellePerson_Lesen()
        If m_Moving Then Exit Sub
        TextBoxAktualisierung = True
        If ListView1.SelectedItems.Count = 0 Then
            Me.TextBoxNachname.Text = ""
            Me.TextBoxVorname.Text = ""
            Me.CheckBoxMaennlich.Checked = False
            Me.TextBoxNachname.Enabled = False
            Me.TextBoxVorname.Enabled = False
            Me.CheckBoxMaennlich.Enabled = False
        Else
            Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
            Me.TextBoxNachname.Text = SelItem.Person.Nachname
            Me.TextBoxVorname.Text = SelItem.Person.Vorname
            Me.CheckBoxMaennlich.Checked = SelItem.Person.Maennlich
            Me.TextBoxNachname.Enabled = True
            Me.TextBoxVorname.Enabled = True
            Me.CheckBoxMaennlich.Enabled = True
        End If
        TextBoxAktualisierung = False
    End Sub

    Private Sub TextBoxNachname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNachname.TextChanged
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        SelItem.Person.Nachname = TextBoxNachname.Text
        m_Personen.Geaendert = True
    End Sub

    Private Sub TextBoxVorname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxVorname.TextChanged
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        SelItem.Person.Vorname = TextBoxVorname.Text
        m_Personen.Geaendert = True
    End Sub

    Private Sub CheckBoxMaennlich_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxMaennlich.CheckedChanged
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        SelItem.Person.Maennlich = CheckBoxMaennlich.Checked
        m_Personen.Geaendert = True
    End Sub

#End Region

#Region " Button-Funktionen "

    Private Sub ButtonAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAdd.Click
        Dim PG As New PersonenGenerator
        Dim PS As Person = PG.Create_Person

        m_Personen.Add(PS)
        m_Personen.Geaendert = True
        Dim LVI As New PersonListViewItem(PS)
        Me.ListView1.Items.Add(LVI)
        LVI.Selected = True
        LVI.EnsureVisible()
    End Sub

    Private Sub ButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDelete.Click
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        Dim Idx As Integer = SelItem.Index
        m_Personen.Remove(SelItem.Person)
        SelItem.Remove()
        m_Personen.Geaendert = True
        'Index um 1 vermindern
        If Idx > 0 Then Idx -= 1
        If m_Personen.Count > 0 Then
            ListView1.Items(Idx).Selected = True
        End If
    End Sub

    Private Sub ButtonUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUp.Click
        m_Moving = True
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        Dim Idx As Integer = SelItem.Index

        Me.ListView1.Items.Remove(SelItem)
        m_Personen.Remove(SelItem.Person)
        Me.ListView1.Items.Insert(Idx - 1, SelItem)
        m_Personen.Insert(Idx - 1, SelItem.Person)
        SelItem.Selected = True
        m_Moving = False
        m_Personen.Geaendert = True
        SelItem.EnsureVisible()
    End Sub

    Private Sub ButtonDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDown.Click
        m_Moving = True
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        Dim Idx As Integer = SelItem.Index

        Me.ListView1.Items.Remove(SelItem)
        m_Personen.Remove(SelItem.Person)
        Me.ListView1.Items.Insert(Idx + 1, SelItem)
        m_Personen.Insert(Idx + 1, SelItem.Person)
        SelItem.Selected = True
        m_Moving = False
        m_Personen.Geaendert = True
        SelItem.EnsureVisible()
    End Sub

    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Me.Close()
    End Sub

#End Region

#Region " Extra-Funktionen "

    Private Sub ListView1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.Resize
        'Neueinstellen der Spaltenbreiten im ListView 
        'bei ndern der ListView-Gre
        Dim Halbbreite As Integer = ListView1.Width \ 2
        ListView1.Columns(0).Width = Halbbreite
        ListView1.Columns(1).Width = -2
    End Sub

    Private Function FreienPfadFinden(ByVal DirName As String, ByVal FileName As String, ByVal Extension As String) As String
        Dim Zahl As Integer = 0

        If Not DirName.EndsWith("\") Then DirName &= "\"
        Dim ErgPfad As String = DirName & FileName & Extension

        While (IO.File.Exists(ErgPfad))
            ErgPfad = DirName & FileName & Zahl.ToString & Extension
            Zahl += 1
        End While

        Return ErgPfad
    End Function

#End Region

End Class
