Public Class PersonComparer
    Implements IComparer(Of Person)
    'IComparer ist ein Interface, das das Sortieren von Listen mit Objekten 
    'sehr bequem macht.
    'Mit der Funktion Compare kann man selbst definieren,
    'wie zwei Objekte untereinander verglichen werden sollen

    Private m_NachNachnameSortieren As Boolean = False
    Private m_Aufsteigend As Boolean = False
    Public Sub New(ByVal NachNachnameSortieren As Boolean, ByVal Aufsteigend As Boolean)
        m_NachNachnameSortieren = NachNachnameSortieren
        m_Aufsteigend = Aufsteigend
    End Sub

    Public Function Compare(ByVal x As Person, ByVal y As Person) As Integer Implements System.Collections.Generic.IComparer(Of Person).Compare
        Dim A, B As Person
        If m_Aufsteigend Then
            A = x
            B = y
        Else
            A = y
            B = x
        End If

        If m_NachNachnameSortieren Then
            If A.Nachname <> B.Nachname Then
                Return A.Nachname.CompareTo(B.Nachname)
            Else
                Return A.Vorname.CompareTo(B.Vorname)
            End If
        Else
            If A.Vorname <> B.Vorname Then
                Return A.Vorname.CompareTo(B.Vorname)
            Else
                Return A.Nachname.CompareTo(B.Nachname)
            End If
        End If

    End Function
End Class
